---
title: Device Authentication (Custom Notification)
description: The POST /{{envID}}/deviceAuthentications operation initiates an MFA device authentication flow. The request body requires a user.id attribute to associate a user with the MFA flow.
component: pingone-api
page_id: pingone-api:mfa:mfa-authentication/mfa-device-authentications/initialize_device_authentication_custom_notification
canonical_url: https://developer.pingidentity.com/pingone-api/mfa/mfa-authentication/mfa-device-authentications/initialize_device_authentication_custom_notification.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Device Authentication (Custom Notification)

##

```none
POST {{authPath}}/{{envID}}/deviceAuthentications
```

The `POST /{{envID}}/deviceAuthentications` operation initiates an MFA device authentication flow. The request body requires a `user.id` attribute to associate a user with the MFA flow.

The response returns a device authentication ID that is required for the next steps in the flow. The response also includes a `status` property to specify the next flow step. Common `status` options are `OTP_REQUIRED` (validate a one-time passcode), `PUSH_CONFIRMATION_REQUIRED` (prompt to confirm the authentication), and `DEVICE_SELECTION_REQUIRED` (select a supported device type for MFA actions).

In this example, the body of the request includes a `notification` object to specify that a custom notification should be used.

### Prerequisites

* [Create a user](/pingone/platform/v1/api/#post-create-user) to get a `{{userID}}` for the body. For more information, refer to [Users](/pingone/platform/v1/api/#users).

> **Collapse: Request Model**
>
> | Property                          | Type?  | Required? |
> | --------------------------------- | ------ | --------- |
> | `user.id`                         | String | Required  |
> | `notification`                    | Object | Optional  |
> | `notification.template`           | Object | Optional  |
> | `notification.template.locale`    | String | Optional  |
> | `notification.template.name`      | String | Optional  |
> | `notification.template.variables` | Map    | Optional  |
>
> Refer to the [Device authentications](#device-authentications-data-model) data model for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "user": {
        "id": "{{userID}}"
    },
    "notification": {
        "template": {
            "locale": "fr-CA",
            "name": "transaction",
            "variables": {
                "account": "1234"
            }
        }
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{authPath}}/{{envID}}/deviceAuthentications' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "user": {
        "id": "{{userID}}"
    },
    "notification": {
        "template": {
            "locale": "fr-CA",
            "name": "transaction",
            "variables": {
                "account": "1234"
            }
        }
    }
}'
```

```csharp
var options = new RestClientOptions("{{authPath}}/{{envID}}/deviceAuthentications")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""user"": {" + "\n" +
@"        ""id"": ""{{userID}}""" + "\n" +
@"    }," + "\n" +
@"    ""notification"": {" + "\n" +
@"        ""template"": {" + "\n" +
@"            ""locale"": ""fr-CA""," + "\n" +
@"            ""name"": ""transaction""," + "\n" +
@"            ""variables"": {" + "\n" +
@"                ""account"": ""1234""" + "\n" +
@"            }" + "\n" +
@"        }" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{authPath}}/{{envID}}/deviceAuthentications"
  method := "POST"

  payload := strings.NewReader(`{
    "user": {
        "id": "{{userID}}"
    },
    "notification": {
        "template": {
            "locale": "fr-CA",
            "name": "transaction",
            "variables": {
                "account": "1234"
            }
        }
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /{{envID}}/deviceAuthentications HTTP/1.1
Host: {{authPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "user": {
        "id": "{{userID}}"
    },
    "notification": {
        "template": {
            "locale": "fr-CA",
            "name": "transaction",
            "variables": {
                "account": "1234"
            }
        }
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"user\": {\n        \"id\": \"{{userID}}\"\n    },\n    \"notification\": {\n        \"template\": {\n            \"locale\": \"fr-CA\",\n            \"name\": \"transaction\",\n            \"variables\": {\n                \"account\": \"1234\"\n            }\n        }\n    }\n}");
Request request = new Request.Builder()
  .url("{{authPath}}/{{envID}}/deviceAuthentications")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{authPath}}/{{envID}}/deviceAuthentications",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "user": {
      "id": "{{userID}}"
    },
    "notification": {
      "template": {
        "locale": "fr-CA",
        "name": "transaction",
        "variables": {
          "account": "1234"
        }
      }
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{authPath}}/{{envID}}/deviceAuthentications',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "user": {
      "id": "{{userID}}"
    },
    "notification": {
      "template": {
        "locale": "fr-CA",
        "name": "transaction",
        "variables": {
          "account": "1234"
        }
      }
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{authPath}}/{{envID}}/deviceAuthentications"

payload = json.dumps({
  "user": {
    "id": "{{userID}}"
  },
  "notification": {
    "template": {
      "locale": "fr-CA",
      "name": "transaction",
      "variables": {
        "account": "1234"
      }
    }
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{authPath}}/{{envID}}/deviceAuthentications');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "user": {\n        "id": "{{userID}}"\n    },\n    "notification": {\n        "template": {\n            "locale": "fr-CA",\n            "name": "transaction",\n            "variables": {\n                "account": "1234"\n            }\n        }\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{authPath}}/{{envID}}/deviceAuthentications")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "user": {
    "id": "{{userID}}"
  },
  "notification": {
    "template": {
      "locale": "fr-CA",
      "name": "transaction",
      "variables": {
        "account": "1234"
      }
    }
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"user\": {\n        \"id\": \"{{userID}}\"\n    },\n    \"notification\": {\n        \"template\": {\n            \"locale\": \"fr-CA\",\n            \"name\": \"transaction\",\n            \"variables\": {\n                \"account\": \"1234\"\n            }\n        }\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{authPath}}/{{envID}}/deviceAuthentications")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://auth.pingone.eu/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/deviceAuthentications/0f29855a-d009-4617-a722-1524d4a93bc2"
        },
        "device.select": {
            "href": "https://auth.pingone.eu/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/deviceAuthentications/0f29855a-d009-4617-a722-1524d4a93bc2"
        }
    },
    "_embedded": {
        "devices": [
            {
                "id": "6697f628-7712-4e71-b52b-920ba0635020",
                "type": "SMS",
                "status": "ACTIVE",
                "usableStatus": {
                    "status": "ENABLED"
                },
                "phone": "*******50",
                "testMode": true
            },
            {
                "id": "37df7055-5fc8-4850-8391-dc2af4289345",
                "type": "VOICE",
                "status": "ACTIVE",
                "usableStatus": {
                    "status": "ENABLED"
                },
                "phone": "*******11",
                "extension": "#313"
            }
        ],
        "blockedDevices": []
    },
    "id": "0f29855a-d009-4617-a722-1524d4a93bc2",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "status": "DEVICE_SELECTION_REQUIRED",
    "policy": {
        "id": "5a0a0950-8a81-4739-b12a-f4d6a11c7a82"
    },
    "user": {
        "id": "b30ac647-e33e-464f-a6ea-0275082d4c26"
    },
    "createdAt": "2023-07-30T11:05:42.378Z",
    "updatedAt": "2023-07-30T11:05:42.436Z"
}
```
